--- apps/app_record.c.orig	2009-02-13 16:43:13.000000000 +0000
+++ apps/app_record.c	2009-07-01 11:45:52.000000000 +0100
@@ -56,6 +56,7 @@
 "     's' : skip recording if the line is not yet answered\n"
 "     't' : use alternate '*' terminator key (DTMF) instead of default '#'\n"
 "     'x' : ignore all terminator keys (DTMF) and keep recording until hangup\n"
+"     'y' : allow any key (DTMF) to terminate instead of just the default '#'\n"
 "\n"
 "If filename contains '%d', these characters will be replaced with a number\n"
 "incremented by one each time the file is recorded. A channel variable\n"
@@ -74,6 +75,7 @@
 	OPTION_IGNORE_TERMINATE = (1 << 5),
 	OPTION_KEEP = (1 << 6),
 	FLAG_HAS_PERCENT = (1 << 7),
+	OPTION_ANY_TERMINATE = (1 << 8),
 };
 
 AST_APP_OPTIONS(app_opts,{
@@ -84,6 +86,7 @@
 	AST_APP_OPTION('s', OPTION_SKIP),
 	AST_APP_OPTION('t', OPTION_STAR_TERMINATE),
 	AST_APP_OPTION('x', OPTION_IGNORE_TERMINATE),
+	AST_APP_OPTION('y', OPTION_ANY_TERMINATE),
 });
 
 static int record_exec(struct ast_channel *chan, void *data)
@@ -318,9 +321,10 @@
 				break;
 			}
 		} else if ((f->frametype == AST_FRAME_DTMF) &&
-		    (f->subclass == terminator)) {
-			ast_frfree(f);
-			break;
+		    (ast_test_flag(&flags, OPTION_ANY_TERMINATE) ||
+			f->subclass == terminator)) {
+				ast_frfree(f);
+				break;
 		}
 		ast_frfree(f);
 	}
